// pages/informationEventCreate/informationEventCreate.ts
import { informationAdd } from '../../apis/information'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    type: 0,
    startDate: '',
    endDate: '',
    sjms: '',
    fileList: [],
    countPic: 9,//上传图片最大数量
    showImgUrl: "", //路径拼接，一般上传返回的都是文件名，
    uploadImgUrl: '',//图片的上传的路径,
    eventId: '',
    eventName: '',
    gwmc: '',
    endDateTyeps: [{ name: '当天', value: 0 }, { name: '至今', value: 1 }, { name: '时间选择', value: 2 }],
    endDateType: ''
  },
  bindDateChange(e) {
    this.setData({
      [e.currentTarget.dataset.key]: e.detail.value
    })
  },

  handleType(e) {
    // console.log(e.currentTarget.dataset.type);
    // let { type } = this.data;

    this.setData({
      type: e.currentTarget.dataset.type,
      endDate: ''
    })
  },
  handleCreate() {
    // console.log(this.data);
    let { startDate, endDate, fileList, eventId, eventName, sjms, gwmc, type } = this.data

    let payload = {}



    if (eventName === '岗位记录') {
      if (!gwmc) {
        wx.showToast({
          icon: 'none',
          title: `请输入岗位名称`
        })
        return
      }
      payload = {
        jsonObject: {
          [eventId]: [{
            [eventName]: [{
              '岗位名称': gwmc,
              '内容': sjms,
              '时间': startDate + (endDate ? ',' + endDate : ''),
              '附件': fileList.map(item => item.url).toString()
            }]
          }]
        }
      }
    } else {
      if (eventName === '社会活动经历') {

        if (!sjms) {
          wx.showToast({
            icon: 'none',
            title: `请输入事件描述`
          })
          return
        }
        payload = {
          jsonObject: {
            [eventId]: [{
              '事件/活动记录': [{
                '内容': sjms,
                '时间': startDate + (endDate ? ',' + endDate : ''),
                '附件': fileList.map(item => item.url).toString()
              }]
            }]
          }
        }
      } else {
        payload = {
          jsonObject: {
            [eventId]: [{
              [eventName]: [{
                '内容': sjms,
                '时间': startDate + (endDate ? ',' + endDate : ''),
                '附件': fileList.map(item => item.url).toString()
              }]
            }]
          }
        }
      }

      // Object.keys(payload[eventId][0][eventName][0]).forEach(key=>{
      //   if(payload[eventId][0][eventName][0][key]===''){
      //     delete payload[eventId][0][eventName][0][key]
      //   }
      // })
    }

    if (type === 0) {
      if (!startDate) {
        wx.showToast({
          icon: 'none',
          title: `请选择开始时间`
        })
        return
      }
      if (!endDate) {
        wx.showToast({
          icon: 'none',
          title: `请选择结束时间`
        })
        return
      }
      if (new Date(startDate).getTime() > new Date(endDate).getTime()) {
        wx.showToast({
          icon: 'none',
          title: `时间范围不正确`
        })
        return
      }
    } else {
      if (!startDate) {
        wx.showToast({
          icon: 'none',
          title: `请选择开始时间`
        })
        return
      }
    }
    if (!sjms) {
      wx.showToast({
        icon: 'none',
        title: `请选择${eventName === '事件/活动记录' ? '事件描述' : '岗位描述'}`
      })
      return
    }

    informationAdd(payload).then((res: any) => {
      if (res.c === 200) {
        wx.navigateBack({
          delta: 1
        })
      }
    })
  },
  handleDeleteFile(e) {
    let { fileList } = this.data
    fileList.splice(e.currentTarget.dataset.index, 1)
    this.setData({
      fileList
    })
  },
  //监听组件事件，返回的结果
  myEventListener: function (e) {
    console.log("上传的图片结果集合")
    console.log(e.detail.picsList)
    this.setData({
      fileList: e.detail.picsList
    })
  },
  radioChange(e) {
    console.log(e);
    const value = Number(e.detail.value)
    switch (value) {
      case 0:
        this.setData({
          endDate: '当天',
          endDateType: value
        })
        break;
      case 1:
        this.setData({
          endDate: '至今',
          endDateType: value
        })
        break;
      case 2:
        this.setData({
          endDate: '',
          endDateType: value
        })
        break;
    }

  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad() {
    this.setData({
      eventId: wx.getStorageSync('eventId'),
      eventName: wx.getStorageSync('eventName')
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})